// -*- C++ -*-
// --------------------------------------------------------------------
// Overlay for creating IpeArc objects
// --------------------------------------------------------------------
/*

    This file is part of the extensible drawing editor Ipe.
    Copyright (C) 1993-2003  Otfried Cheong

    Ipe is free software; you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Ipe is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License
    along with Ipe; if not, you can find it at
    "http://www.gnu.org/copyleft/gpl.html", or write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef CREATEARC_H
#define CREATEARC_H

#include "overlay.h"
#include "ipepath.h"

// --------------------------------------------------------------------

class CreateCircle : public Overlay {
 public:
  enum TMode { ECenterRadius, EDiameter, E3Points };

  CreateCircle(QMouseEvent *ev, Canvas *canvas, ObjectAdder *objectAdder,
	       TMode mode);

  virtual void Draw(QPaintEvent *ev, QPainter *painter) const;
  virtual void MousePress(QMouseEvent *ev);
  virtual void MouseMove(QMouseEvent *ev);

 private:
  IpePath Create() const;
 private:
  ObjectAdder *iObjectAdder;
  TMode iMode;
  IpeVector iV[3];
  int iCur;
};

// --------------------------------------------------------------------

class CreateArc : public Overlay {
 public:
  enum TMode { ECenterRightLeft, ECenterLeftRight, E3Points };

  CreateArc(QMouseEvent *ev, Canvas *canvas, ObjectAdder *objectAdder,
	    TMode mode);

  virtual void Draw(QPaintEvent *ev, QPainter *painter) const;
  virtual void MousePress(QMouseEvent *ev);
  virtual void MouseMove(QMouseEvent *ev);

 private:
  IpePath Create() const;
 private:
  ObjectAdder *iObjectAdder;
  TMode iMode;
  IpeVector iV[3];
  int iCur;
};

// --------------------------------------------------------------------
#endif
