// -*- C++ -*-
// --------------------------------------------------------------------
// Window displaying debug output
// --------------------------------------------------------------------
/*

    This file is part of the extensible drawing editor Ipe.
    Copyright (C) 1993-2003  Otfried Cheong

    Ipe is free software; you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Ipe is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License
    along with Ipe; if not, you can find it at
    "http://www.gnu.org/copyleft/gpl.html", or write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef DEBUGWIN_H
#define DEBUGWIN_H

#include "ipebase.h"
#include <qmainwindow.h>

class QMultiLineEdit;
class QPopupMenu;

class DebugWindow : public QMainWindow {
  Q_OBJECT
public:
  static void Show();
  static IpeStream &Stream();

private:
  static DebugWindow *This;
  static IpeStream *stream;

  DebugWindow();
  ~DebugWindow();
  void Message(QString str);

  friend class IpeDebugStream;

private:
  QMultiLineEdit* iView;
};

#define DBG DebugWindow::Stream()

// --------------------------------------------------------------------
#endif
