// -*- C++ -*-
// --------------------------------------------------------------------
// Style sheet dialog
// --------------------------------------------------------------------
/*

    This file is part of the extensible drawing editor Ipe.
    Copyright (C) 1993-2003  Otfried Cheong

    Ipe is free software; you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Ipe is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License
    along with Ipe; if not, you can find it at
    "http://www.gnu.org/copyleft/gpl.html", or write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef STYLES_H
#define STYLES_H

#include "dlgstyles.h"

// --------------------------------------------------------------------

class IpePdfDocument;
class QListBoxItem;

class DialogStyles : public DlgStyles {
  Q_OBJECT
public:
  DialogStyles(QWidget* parent, IpePdfDocument *doc);
public slots:
  virtual void ShowHelp();
  virtual void AddNew();
  virtual void Remove();
  virtual void Save();
  virtual void MoveUp();
  virtual void MoveDown();
  virtual void CurrentChanged(QListBoxItem *);
private:
  void ErrMsg(QString str);
  void UpdateList();
  void UpdateButtons();
private:
  IpePdfDocument *iDoc;
};

// --------------------------------------------------------------------
#endif
